---
title: Inner and outer windows
slug: Mozilla/Developer_guide/Inner_and_outer_windows
tags:
  - DOM
  - Window
---
<p>{{ draft() }}</p>
<p>This article will try to explain the concepts of inner and outer windows.</p>
<p>Consider that when the user is looking at a document in a browser window, not only can the document the user is currently viewing change, but the document's contents can change. Then add to that the concept of frames, whereby a document in a window can itself contain other documents, which in turn can contain more documents.</p>
<p>In order to represent these levels of complexity, two "types" of window need to be considered. These don't technically refer to windows as the user sees them, but rather a perspective on what the user is looking at.</p>
<h2 id="Windows_and_the_bfcache">Windows and the bfcache</h2>
<p>An <strong>outer window</strong> is a <a class="external" href="http://www.whatwg.org/specs/web-apps/current-work/multipage/browsers.html#browsing-context">browsing context</a>; that is, the actual environment in which a {{ domxref("Document") }} is presented to the user. This may be a window or a tab, or it might be an {{ HTMLElement("iframe") }} contained within another document. HTML5 refers to the outer window as the <a class="external" href="http://www.whatwg.org/specs/web-apps/current-work/multipage/browsers.html#the-windowproxy-object"><code>WindowProxy</code></a>.</p>
<p>An <strong>inner window</strong> represents the actual content being displayed; it's the current view of what the user sees.</p>
<p>Consider this view of a window and the browser history:</p>
<p><img alt="window-strip.png" class="internal default" src="/@api/deki/files/4736/=window-strip.png"></p>
<p>As the user navigates, documents are added to the backward-forward cache (often referred to as the <strong>bfcache</strong>). These are, in essence, inner windows. They get displayed in the outer window, which is contained in the "physical" browser window.</p>
<p>Here's the trick, though: the inner window in essence pretends to be the outer window. If the document currently being displayed asks "what window am I in?", it gets the outer window as the answer. That lets the document interact with the "physical" window, while the outer window can keep track of all the documents (inner windows) it contains. In other words, {{ domxref("window") }} always returns the outer window.</p>
<h2 id="Nested_windows">Nested windows</h2>
<p>Things become slightly more complex when you consider that documents can contain other documents. This happens, for example, when a {{ domxref("document") }} contains a {{ HTMLElement("frame") }} or {{ HTMLElement("iframe") }}. Not only can the outermost document be navigated, but if the user clicks a link in one of the frames, that frame can navigate.</p>
<p>This means there needs to be a hierarchy of outer and inner windows. Consider a document that has three {{ HTMLElement("iframe") }} elements in it. The hierarchy would look something like this:</p>
<p><img alt="iframes-hierarchy.png" class="internal default" src="/@api/deki/files/4737/=iframes-hierarchy.png"></p>
<p>In this diagram, objects you interact with directly in the DOM (that is, {{ domxref("Window") }}, {{ domxref("Document") }}, and {{ domxref("Element") }} objects) are blue. The grey circles represent the more abstract inner and outer windows, which are real objects that you don't directly interact with when working with the DOM.  The Window at the top of the diagram is an outer window.</p>
<p>As the user navigates in each of the documents in the various frames, each of those inner windows has its own history that can be moved forward and backward through, just like in the previous diagram.</p>
<p>The {{ HTMLElement("iframe") }} element offers the <code>contentWindow</code> property, which gives you the outer window {{ domxref("Window") }} object containing the frame's document. The frame's <code>contentDocument</code> property, similarly, gives you the {{ domxref("Document") }} object inside the frame.</p>
<p>You can get the window containing the frame from the {{ domxref("window.parent") }} property.</p>
<p>This hierarchy can continue on, if frames contain additional frames.</p>
